package com.jiuqi.dna.ide.designer.workflow;

import com.jiuqi.dna.ide.designer.elements.IFigureElement;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.MouseEvent;
import org.eclipse.draw2d.MouseMotionListener;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.TextLayout;
import org.eclipse.swt.widgets.Display;

/* loaded from: com_jiuqi_dna_ide_designer_workflow.jar:com/jiuqi/dna/ide/designer/workflow/WorkflowNodeFigure.class */
public class WorkflowNodeFigure extends Figure {
    private IFigureElement figureElement;
    Point mouseLocation;

    public WorkflowNodeFigure() {
        setLayoutManager(new XYLayout());
        addMouseMotionListener(new MouseMotionListener.Stub() { // from class: com.jiuqi.dna.ide.designer.workflow.WorkflowNodeFigure.1
            public void mouseMoved(MouseEvent me) {
                WorkflowNodeFigure.this.mouseLocation = me.getLocation();
            }

            public void mouseExited(MouseEvent me) {
                WorkflowNodeFigure.this.mouseLocation = null;
            }
        });
    }

    protected void paintFigure(Graphics graphics) {
        int i;
        graphics.setAntialias(1);
        if (this.figureElement == null) {
            return;
        }
        Rectangle r = getBounds();
        graphics.setAlpha(255);
        Image image = this.figureElement.getImage();
        Rectangle dest = new Rectangle();
        dest.x = r.x + 4;
        dest.y = r.y + 4;
        if (image != null) {
            dest.height = image.getBounds().height;
            dest.width = image.getBounds().width;
            graphics.drawImage(image, new Rectangle(image.getBounds()), dest);
        }
        TextLayout textLayout = new TextLayout(Display.getCurrent());
        textLayout.setText(this.figureElement.getText());
        graphics.drawTextLayout(textLayout, dest.x + dest.width + 4, dest.y);
        Rectangle re = new Rectangle();
        re.setBounds(r);
        if (dest.height <= textLayout.getBounds().height) {
            i = textLayout.getBounds().height + (4 * 2);
        } else {
            i = dest.height + (4 * 2);
        }
        re.height = i;
        re.width = 4 + dest.width + 4 + textLayout.getBounds().width + 4;
        setBounds(re);
        this.figureElement.setSize(re.width, re.height);
        Rectangle rec = new Rectangle();
        rec.setBounds(re);
        rec.height--;
        rec.width--;
        graphics.drawRoundRectangle(rec, 10, 10);
    }

    protected boolean useLocalCoordinates() {
        return true;
    }

    public void setFigureElement(IFigureElement figureElement) {
        this.figureElement = figureElement;
    }
}
